c*** File iolib/constr.f
c*** February 22, 1993
c*** By Doug Mink, Center for Astrophysics

	Subroutine CONSTR (STR1,STR2)

c--- Concatenate character string STR2 onto the end of STR1
c    The lengths allow character string literals to be dealt with

	Character*(*) STR1
c			Character string (NULL-terminated or space-padded)
	Character*(*) STR2
c			Character string (NULL-terminated or space-padded)

	Character NULL*1
	Integer*4 MAXLEN,LEN1,LEN2,L,L1

c  Find length of first string (root)

	MAXLEN = Len (STR1)
	Call VLEN (STR1,LEN1)
	If (LEN1 .gt. MAXLEN)  Then
	    LEN1 = MAXLEN
	    Write(*,*) '*** Length of',STR1,'is',LEN1,'/',MAXLEN
	    Return
	    Endif

c  Find length of second string; use less if total length too long

	Call VLEN (STR2,LEN2)
	If ((LEN1+LEN2) .gt. MAXLEN) LEN2 = MAXLEN - LEN1

c  Concatenate strings and pad with NULLs

	If (LEN2 .gt. 0) Then
	    STR1(LEN1+1:LEN1+LEN2) = STR2(1:LEN2)
	    L1 = LEN1 + LEN2 + 1
	    If (L1 .lt. MAXLEN) Then
		NULL = Char (0)
		Do 30 L = L1, MAXLEN
30		    STR1(L:L) = NULL
		Endif
	    Endif

	Return
	End

c Feb 22 1993	Declare undeclared variable l1
