
/*  A Bison parser, made from getdate.y with Bison version GNU Bison version 1.22
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	tAGO	258
#define	tDAY	259
#define	tDAYZONE	260
#define	tID	261
#define	tMERIDIAN	262
#define	tMINUTE_UNIT	263
#define	tMONTH	264
#define	tMONTH_UNIT	265
#define	tSEC_UNIT	266
#define	tSNUMBER	267
#define	tUNUMBER	268
#define	tZONE	269
#define	tDST	270

#line 1 "getdate.y"

/* $Revision: 1.2 $
**
**  Originally written by Steven M. Bellovin <smb@research.att.com> while
**  at the University of North Carolina at Chapel Hill.  Later tweaked by
**  a couple of people on Usenet.  Completely overhauled by Rich $alz
**  <rsalz@bbn.com> and Jim Berets <jberets@bbn.com> in August, 1990;
**  send any email to Rich.
**
**  This grammar has eight shift/reduce conflicts.
**
**  This code is in the public domain and has no copyright.
*/
/* SUPPRESS 287 on yaccpar_sccsid *//* Unusd static variable */
/* SUPPRESS 288 on gd_errlab *//* Label unused */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __GNUC__
#define alloca __builtin_alloca
#else
#ifdef HAVE_ALLOCA_H
#include <alloca.h>
#else
#ifdef _AIX /* for Bison */
 #pragma alloca
#else
#define gd_overflow	dateoverflow

static dateoverflow() {
	return 1;
}

char *alloca ();
#endif
#endif
#endif


#include <stdio.h>
#include <ctype.h>

/* The code at the top of get_date which figures out the offset of the
   current time zone checks various CPP symbols to see if special
   tricks are need, but defaults to using the gettimeofday system call.
   Include <sys/time.h> if that will be used.  */

#if !defined (USG) && !defined (sgi) && !defined (__FreeBSD__)
#include <sys/time.h>
#endif

#if	defined(vms)

#include <types.h>
#include <time.h>

#else

#include <sys/types.h>

#if	defined(BSD4_2) || defined(BSD4_1C) || (defined (hp9000) && !defined (hpux))
#include <sys/time.h>
#else
#if defined(_AIX)
#include <sys/time.h>
#endif
#include <time.h>
#endif	/* defined(BSD4_2) */
#endif	/* defined(vms) */

#if defined (STDC_HEADERS) || defined (USG)
#include <string.h>
#endif

#if sgi
#undef timezone
#endif

extern struct tm	*localtime();

#define gd_parse getdate_gd_parse
#define gd_lex getdate_gd_lex
#define gd_error getdate_gd_error

#define HOUR(x)		((int)(x) * 60)
#define SECSPERDAY	(24L * 60L * 60L)

#include "slalib.h"

#define MJD1970	40587
#define MJDtoUNIXTIME(mjd)	((int) (((mjd - MJD1970) * SECSPERDAY) + .5))


/*
**  An entry in the lexical lookup table.
*/
typedef struct _TABLE {
    char	*name;
    int		type;
    time_t	value;
} TABLE;


/*
**  Daylight-savings mode:  on, off, or not yet known.
*/
typedef enum _DSTMODE {
    DSTon, DSToff, DSTmaybe
} DSTMODE;

/*
**  Meridian:  am, pm, or 24-hour style.
*/
typedef enum _MERIDIAN {
    MERam, MERpm, MER24
} MERIDIAN;


/*
**  Global variables.  We could get rid of most of these by using a good
**  union as the yacc stack.  (This routine was originally written before
**  yacc had the %union construct.)  Maybe someday; right now we only use
**  the %union very rarely.
*/
static char	*gd_Input;
static DSTMODE	gd_DSTmode;
static time_t	gd_DayOrdinal;
static time_t	gd_DayNumber;
static int	gd_HaveDate;
static int	gd_HaveDay;
static int	gd_HaveRel;
static int	gd_HaveTime;
static int	gd_HaveZone;
static time_t	gd_Timezone;
static time_t	gd_Day;
static time_t	gd_Hour;
static time_t	gd_Minutes;
static time_t	gd_Month;
static time_t	gd_Seconds;
static time_t	gd_Year;
static MERIDIAN	gd_Meridian;
static time_t	gd_RelMonth;
static time_t	gd_RelSeconds;

static getdate_gd_error();
static getdate_gd_lex();

#line 151 "getdate.y"
typedef union {
    time_t		Number;
    enum _MERIDIAN	Meridian;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct gd_ltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  gd_ltype;

#define YYLTYPE gd_ltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		56
#define	YYFLAG		-32768
#define	YYNTBASE	20

#define YYTRANSLATE(x) ((unsigned)(x) <= 270 ? gd_translate[x] : 30)

static const char gd_translate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,    17,    19,     2,    18,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    16,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15
};

#if YYDEBUG != 0
static const short gd_prhs[] = {     0,
     0,     1,     4,     6,     8,    10,    12,    14,    16,    19,
    24,    29,    36,    43,    45,    47,    50,    52,    55,    58,
    62,    68,    72,    75,    80,    84,    89,    92,    96,    99,
   101,   104,   107,   109,   112,   115,   117,   120,   123,   125,
   127,   128
};

static const short gd_rhs[] = {    -1,
    20,    21,     0,    22,     0,    23,     0,    25,     0,    24,
     0,    26,     0,    28,     0,    13,     7,     0,    13,    16,
    13,    29,     0,    13,    16,    13,    12,     0,    13,    16,
    13,    16,    13,    29,     0,    13,    16,    13,    16,    13,
    12,     0,    14,     0,     5,     0,    14,    15,     0,     4,
     0,     4,    17,     0,    13,     4,     0,    13,    18,    13,
     0,    13,    18,    13,    18,    13,     0,    13,    12,    12,
     0,     9,    13,     0,    13,    19,     9,    12,     0,     9,
    12,    12,     0,     9,    13,    17,    13,     0,    13,     9,
     0,    13,     9,    13,     0,    27,     3,     0,    27,     0,
    13,     8,     0,    12,     8,     0,     8,     0,    12,    11,
     0,    13,    11,     0,    11,     0,    12,    10,     0,    13,
    10,     0,    10,     0,    13,     0,     0,     7,     0
};

#endif

#if YYDEBUG != 0
static const short gd_rline[] = { 0,
   165,   166,   169,   172,   175,   178,   181,   184,   187,   193,
   199,   206,   212,   222,   226,   230,   237,   241,   245,   251,
   255,   260,   266,   270,   275,   280,   285,   289,   296,   300,
   303,   306,   309,   312,   315,   318,   321,   324,   327,   332,
   358,   361
};

static const char * const gd_tname[] = {   "$","error","$illegal.","tAGO","tDAY",
"tDAYZONE","tID","tMERIDIAN","tMINUTE_UNIT","tMONTH","tMONTH_UNIT","tSEC_UNIT",
"tSNUMBER","tUNUMBER","tZONE","tDST","':'","','","'/'","'-'","spec","item","time",
"zone","day","date","rel","relunit","number","o_merid",""
};
#endif

static const short gd_r1[] = {     0,
    20,    20,    21,    21,    21,    21,    21,    21,    22,    22,
    22,    22,    22,    23,    23,    23,    24,    24,    24,    25,
    25,    25,    25,    25,    25,    25,    25,    25,    26,    26,
    27,    27,    27,    27,    27,    27,    27,    27,    27,    28,
    29,    29
};

static const short gd_r2[] = {     0,
     0,     2,     1,     1,     1,     1,     1,     1,     2,     4,
     4,     6,     6,     1,     1,     2,     1,     2,     2,     3,
     5,     3,     2,     4,     3,     4,     2,     3,     2,     1,
     2,     2,     1,     2,     2,     1,     2,     2,     1,     1,
     0,     1
};

static const short gd_defact[] = {     1,
     0,    17,    15,    33,     0,    39,    36,     0,    40,    14,
     2,     3,     4,     6,     5,     7,    30,     8,    18,     0,
    23,    32,    37,    34,    19,     9,    31,    27,    38,    35,
     0,     0,     0,     0,    16,    29,    25,     0,    28,    22,
    41,    20,     0,    26,    42,    11,     0,    10,     0,    24,
    41,    21,    13,    12,     0,     0
};

static const short gd_defgoto[] = {     1,
    11,    12,    13,    14,    15,    16,    17,    18,    48
};

static const short gd_pact[] = {-32768,
    13,    -8,-32768,-32768,   -11,-32768,-32768,    24,    -4,    -5,
-32768,-32768,-32768,-32768,-32768,-32768,    16,-32768,-32768,    17,
    14,-32768,-32768,-32768,-32768,-32768,-32768,    23,-32768,-32768,
    18,    25,    26,    28,-32768,-32768,-32768,    27,-32768,-32768,
     4,    29,    30,-32768,-32768,-32768,    31,-32768,    32,-32768,
    21,-32768,-32768,-32768,    41,-32768
};

static const short gd_pgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    -3
};


#define	YYLAST		48


static const short gd_table[] = {    25,
    20,    21,    26,    27,    28,    29,    30,    31,    19,    35,
    45,    32,    55,    33,    34,    46,     2,     3,    36,    47,
     4,     5,     6,     7,     8,     9,    10,    45,    37,    40,
    38,    22,    53,    23,    24,    39,    43,    41,    42,    44,
    56,    50,     0,    51,    52,     0,    49,    54
};

static const short gd_check[] = {     4,
    12,    13,     7,     8,     9,    10,    11,    12,    17,    15,
     7,    16,     0,    18,    19,    12,     4,     5,     3,    16,
     8,     9,    10,    11,    12,    13,    14,     7,    12,    12,
    17,     8,    12,    10,    11,    13,     9,    13,    13,    13,
     0,    12,    -1,    13,    13,    -1,    18,    51
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/home/john/.bin.SunOS5.3/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define gd_errok		(gd_errstatus = 0)
#define gd_clearin	(gd_char = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto gd_errlab1
/* Like YYERROR except do call gd_error.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto gd_errlab
#define YYRECOVERING()  (!!gd_errstatus)
#define YYBACKUP(token, value) \
do								\
  if (gd_char == YYEMPTY && gd_len == 1)				\
    { gd_char = (token), gd_lval = (value);			\
      gd_char1 = YYTRANSLATE (gd_char);				\
      YYPOPSTACK;						\
      goto gd_backup;						\
    }								\
  else								\
    { gd_error ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		gd_lex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		gd_lex(&gd_lval, &gd_lloc)
#else
#define YYLEX		gd_lex(&gd_lval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	gd_char;			/*  the lookahead symbol		*/
YYSTYPE	gd_lval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE gd_lloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int gd_nerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int gd_debug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int gd_parse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __gd__bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__gd__bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__gd__bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 184 "/home/john/.bin.SunOS5.3/bison.simple"
int
gd_parse()
{
  register int gd_state;
  register int gd_n;
  register short *gd_ssp;
  register YYSTYPE *gd_vsp;
  int gd_errstatus;	/*  number of tokens to shift before error messages enabled */
  int gd_char1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	gd_ssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE gd_vsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *gd_ss = gd_ssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *gd_vs = gd_vsa;	/*  to allow gd_overflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE gd_lsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *gd_ls = gd_lsa;
  YYLTYPE *gd_lsp;

#define YYPOPSTACK   (gd_vsp--, gd_ssp--, gd_lsp--)
#else
#define YYPOPSTACK   (gd_vsp--, gd_ssp--)
#endif

  int gd_stacksize = YYINITDEPTH;

#ifdef YYPURE
  int gd_char;
  YYSTYPE gd_lval;
  int gd_nerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE gd_lloc;
#endif
#endif

  YYSTYPE gd_val;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int gd_len;

#if YYDEBUG != 0
  if (gd_debug)
    fprintf(stderr, "Starting parse\n");
#endif

  gd_state = 0;
  gd_errstatus = 0;
  gd_nerrs = 0;
  gd_char = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  gd_ssp = gd_ss - 1;
  gd_vsp = gd_vs;
#ifdef YYLSP_NEEDED
  gd_lsp = gd_ls;
#endif

/* Push a new state, which is found in  gd_state  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
gd_newstate:

  *++gd_ssp = gd_state;

  if (gd_ssp >= gd_ss + gd_stacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *gd_vs1 = gd_vs;
      short *gd_ss1 = gd_ss;
#ifdef YYLSP_NEEDED
      YYLTYPE *gd_ls1 = gd_ls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = gd_ssp - gd_ss + 1;

#ifdef gd_overflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if gd_overflow is a macro.  */
      gd_overflow("parser stack overflow",
		 &gd_ss1, size * sizeof (*gd_ssp),
		 &gd_vs1, size * sizeof (*gd_vsp),
		 &gd_ls1, size * sizeof (*gd_lsp),
		 &gd_stacksize);
#else
      gd_overflow("parser stack overflow",
		 &gd_ss1, size * sizeof (*gd_ssp),
		 &gd_vs1, size * sizeof (*gd_vsp),
		 &gd_stacksize);
#endif

      gd_ss = gd_ss1; gd_vs = gd_vs1;
#ifdef YYLSP_NEEDED
      gd_ls = gd_ls1;
#endif
#else /* no gd_overflow */
      /* Extend the stack our own way.  */
      if (gd_stacksize >= YYMAXDEPTH)
	{
	  gd_error("parser stack overflow");
	  return 2;
	}
      gd_stacksize *= 2;
      if (gd_stacksize > YYMAXDEPTH)
	gd_stacksize = YYMAXDEPTH;
      gd_ss = (short *) alloca (gd_stacksize * sizeof (*gd_ssp));
      __gd__bcopy ((char *)gd_ss1, (char *)gd_ss, size * sizeof (*gd_ssp));
      gd_vs = (YYSTYPE *) alloca (gd_stacksize * sizeof (*gd_vsp));
      __gd__bcopy ((char *)gd_vs1, (char *)gd_vs, size * sizeof (*gd_vsp));
#ifdef YYLSP_NEEDED
      gd_ls = (YYLTYPE *) alloca (gd_stacksize * sizeof (*gd_lsp));
      __gd__bcopy ((char *)gd_ls1, (char *)gd_ls, size * sizeof (*gd_lsp));
#endif
#endif /* no gd_overflow */

      gd_ssp = gd_ss + size - 1;
      gd_vsp = gd_vs + size - 1;
#ifdef YYLSP_NEEDED
      gd_lsp = gd_ls + size - 1;
#endif

#if YYDEBUG != 0
      if (gd_debug)
	fprintf(stderr, "Stack size increased to %d\n", gd_stacksize);
#endif

      if (gd_ssp >= gd_ss + gd_stacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (gd_debug)
    fprintf(stderr, "Entering state %d\n", gd_state);
#endif

  goto gd_backup;
 gd_backup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* gd_resume: */

  /* First try to decide what to do without reference to lookahead token.  */

  gd_n = gd_pact[gd_state];
  if (gd_n == YYFLAG)
    goto gd_default;

  /* Not known => get a lookahead token if don't already have one.  */

  /* gd_char is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (gd_char == YYEMPTY)
    {
#if YYDEBUG != 0
      if (gd_debug)
	fprintf(stderr, "Reading a token: ");
#endif
      gd_char = YYLEX;
    }

  /* Convert token to internal form (in gd_char1) for indexing tables with */

  if (gd_char <= 0)		/* This means end of input. */
    {
      gd_char1 = 0;
      gd_char = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (gd_debug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      gd_char1 = YYTRANSLATE(gd_char);

#if YYDEBUG != 0
      if (gd_debug)
	{
	  fprintf (stderr, "Next token is %d (%s", gd_char, gd_tname[gd_char1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, gd_char, gd_lval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  gd_n += gd_char1;
  if (gd_n < 0 || gd_n > YYLAST || gd_check[gd_n] != gd_char1)
    goto gd_default;

  gd_n = gd_table[gd_n];

  /* gd_n is what to do for this token type in this state.
     Negative => reduce, -gd_n is rule number.
     Positive => shift, gd_n is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (gd_n < 0)
    {
      if (gd_n == YYFLAG)
	goto gd_errlab;
      gd_n = -gd_n;
      goto gd_reduce;
    }
  else if (gd_n == 0)
    goto gd_errlab;

  if (gd_n == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (gd_debug)
    fprintf(stderr, "Shifting token %d (%s), ", gd_char, gd_tname[gd_char1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (gd_char != YYEOF)
    gd_char = YYEMPTY;

  *++gd_vsp = gd_lval;
#ifdef YYLSP_NEEDED
  *++gd_lsp = gd_lloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (gd_errstatus) gd_errstatus--;

  gd_state = gd_n;
  goto gd_newstate;

/* Do the default action for the current state.  */
gd_default:

  gd_n = gd_defact[gd_state];
  if (gd_n == 0)
    goto gd_errlab;

/* Do a reduction.  gd_n is the number of a rule to reduce with.  */
gd_reduce:
  gd_len = gd_r2[gd_n];
  if (gd_len > 0)
    gd_val = gd_vsp[1-gd_len]; /* implement default value of the action */

#if YYDEBUG != 0
  if (gd_debug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       gd_n, gd_rline[gd_n]);

      /* Print the symbols being reduced, and their result.  */
      for (i = gd_prhs[gd_n]; gd_rhs[i] > 0; i++)
	fprintf (stderr, "%s ", gd_tname[gd_rhs[i]]);
      fprintf (stderr, " -> %s\n", gd_tname[gd_r1[gd_n]]);
    }
#endif


  switch (gd_n) {

case 3:
#line 169 "getdate.y"
{
	    gd_HaveTime++;
	;
    break;}
case 4:
#line 172 "getdate.y"
{
	    gd_HaveZone++;
	;
    break;}
case 5:
#line 175 "getdate.y"
{
	    gd_HaveDate++;
	;
    break;}
case 6:
#line 178 "getdate.y"
{
	    gd_HaveDay++;
	;
    break;}
case 7:
#line 181 "getdate.y"
{
	    gd_HaveRel++;
	;
    break;}
case 9:
#line 187 "getdate.y"
{
	    gd_Hour = gd_vsp[-1].Number;
	    gd_Minutes = 0;
	    gd_Seconds = 0;
	    gd_Meridian = gd_vsp[0].Meridian;
	;
    break;}
case 10:
#line 193 "getdate.y"
{
	    gd_Hour = gd_vsp[-3].Number;
	    gd_Minutes = gd_vsp[-1].Number;
	    gd_Seconds = 0;
	    gd_Meridian = gd_vsp[0].Meridian;
	;
    break;}
case 11:
#line 199 "getdate.y"
{
	    gd_Hour = gd_vsp[-3].Number;
	    gd_Minutes = gd_vsp[-1].Number;
	    gd_Meridian = MER24;
	    gd_DSTmode = DSToff;
	    gd_Timezone = - (gd_vsp[0].Number % 100 + (gd_vsp[0].Number / 100) * 60);
	;
    break;}
case 12:
#line 206 "getdate.y"
{
	    gd_Hour = gd_vsp[-5].Number;
	    gd_Minutes = gd_vsp[-3].Number;
	    gd_Seconds = gd_vsp[-1].Number;
	    gd_Meridian = gd_vsp[0].Meridian;
	;
    break;}
case 13:
#line 212 "getdate.y"
{
	    gd_Hour = gd_vsp[-5].Number;
	    gd_Minutes = gd_vsp[-3].Number;
	    gd_Seconds = gd_vsp[-1].Number;
	    gd_Meridian = MER24;
	    gd_DSTmode = DSToff;
	    gd_Timezone = - (gd_vsp[0].Number % 100 + (gd_vsp[0].Number / 100) * 60);
	;
    break;}
case 14:
#line 222 "getdate.y"
{
	    gd_Timezone = gd_vsp[0].Number;
	    gd_DSTmode = DSToff;
	;
    break;}
case 15:
#line 226 "getdate.y"
{
	    gd_Timezone = gd_vsp[0].Number;
	    gd_DSTmode = DSTon;
	;
    break;}
case 16:
#line 231 "getdate.y"
{
	    gd_Timezone = gd_vsp[-1].Number;
	    gd_DSTmode = DSTon;
	;
    break;}
case 17:
#line 237 "getdate.y"
{
	    gd_DayOrdinal = 1;
	    gd_DayNumber = gd_vsp[0].Number;
	;
    break;}
case 18:
#line 241 "getdate.y"
{
	    gd_DayOrdinal = 1;
	    gd_DayNumber = gd_vsp[-1].Number;
	;
    break;}
case 19:
#line 245 "getdate.y"
{
	    gd_DayOrdinal = gd_vsp[-1].Number;
	    gd_DayNumber = gd_vsp[0].Number;
	;
    break;}
case 20:
#line 251 "getdate.y"
{
	    gd_Month = gd_vsp[-2].Number;
	    gd_Day = gd_vsp[0].Number;
	;
    break;}
case 21:
#line 255 "getdate.y"
{
	    gd_Day = gd_vsp[-4].Number;
	    gd_Month = gd_vsp[-2].Number;
	    gd_Year = gd_vsp[0].Number;
	;
    break;}
case 22:
#line 260 "getdate.y"
{
	    /* ISO 8601 format.  gd_gd_-mm-dd.  */
	    gd_Year = gd_vsp[-2].Number;
	    gd_Month = -gd_vsp[-1].Number;
	    gd_Day = -gd_vsp[0].Number;
	;
    break;}
case 23:
#line 266 "getdate.y"
{
	    gd_Month = gd_vsp[-1].Number;
	    gd_Day = gd_vsp[0].Number;
	;
    break;}
case 24:
#line 270 "getdate.y"
{
	    gd_Day   =  gd_vsp[-3].Number;
	    gd_Month =  gd_vsp[-1].Number;
	    gd_Year  = -gd_vsp[0].Number;
	;
    break;}
case 25:
#line 275 "getdate.y"
{
	    gd_Month =  gd_vsp[-2].Number;
	    gd_Day   = -gd_vsp[-1].Number;
	    gd_Year  = -gd_vsp[0].Number;
	;
    break;}
case 26:
#line 280 "getdate.y"
{
	    gd_Month = gd_vsp[-3].Number;
	    gd_Day = gd_vsp[-2].Number;
	    gd_Year = gd_vsp[0].Number;
	;
    break;}
case 27:
#line 285 "getdate.y"
{
	    gd_Month = gd_vsp[0].Number;
	    gd_Day = gd_vsp[-1].Number;
	;
    break;}
case 28:
#line 289 "getdate.y"
{
	    gd_Month = gd_vsp[-1].Number;
	    gd_Day = gd_vsp[-2].Number;
	    gd_Year = gd_vsp[0].Number;
	;
    break;}
case 29:
#line 296 "getdate.y"
{
	    gd_RelSeconds = -gd_RelSeconds;
	    gd_RelMonth = -gd_RelMonth;
	;
    break;}
case 31:
#line 303 "getdate.y"
{
	    gd_RelSeconds += gd_vsp[-1].Number * gd_vsp[0].Number * 60L;
	;
    break;}
case 32:
#line 306 "getdate.y"
{
	    gd_RelSeconds += gd_vsp[-1].Number * gd_vsp[0].Number * 60L;
	;
    break;}
case 33:
#line 309 "getdate.y"
{
	    gd_RelSeconds += gd_vsp[0].Number * 60L;
	;
    break;}
case 34:
#line 312 "getdate.y"
{
	    gd_RelSeconds += gd_vsp[-1].Number;
	;
    break;}
case 35:
#line 315 "getdate.y"
{
	    gd_RelSeconds += gd_vsp[-1].Number;
	;
    break;}
case 36:
#line 318 "getdate.y"
{
	    gd_RelSeconds++;
	;
    break;}
case 37:
#line 321 "getdate.y"
{
	    gd_RelMonth += gd_vsp[-1].Number * gd_vsp[0].Number;
	;
    break;}
case 38:
#line 324 "getdate.y"
{
	    gd_RelMonth += gd_vsp[-1].Number * gd_vsp[0].Number;
	;
    break;}
case 39:
#line 327 "getdate.y"
{
	    gd_RelMonth += gd_vsp[0].Number;
	;
    break;}
case 40:
#line 332 "getdate.y"
{
	    if (gd_HaveTime && gd_HaveDate && !gd_HaveRel)
		gd_Year = gd_vsp[0].Number;
	    else {
		if(gd_vsp[0].Number>10000) {
		    gd_HaveDate++;
		    gd_Day= (gd_vsp[0].Number)%100;
		    gd_Month= (gd_vsp[0].Number/100)%100;
	    	    gd_Year = gd_vsp[0].Number/10000;
		} else {
		    gd_HaveTime++;
		    if (gd_vsp[0].Number < 100) {
			gd_Hour = gd_vsp[0].Number;
			gd_Minutes = 0;
		    }
		    else {
			gd_Hour = gd_vsp[0].Number / 100;
			gd_Minutes = gd_vsp[0].Number % 100;
		    }
		}
		gd_Seconds = 0;
		gd_Meridian = MER24;
	    }
	;
    break;}
case 41:
#line 358 "getdate.y"
{
	    gd_val.Meridian = MER24;
	;
    break;}
case 42:
#line 361 "getdate.y"
{
	    gd_val.Meridian = gd_vsp[0].Meridian;
	;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 465 "/home/john/.bin.SunOS5.3/bison.simple"

  gd_vsp -= gd_len;
  gd_ssp -= gd_len;
#ifdef YYLSP_NEEDED
  gd_lsp -= gd_len;
#endif

#if YYDEBUG != 0
  if (gd_debug)
    {
      short *ssp1 = gd_ss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != gd_ssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++gd_vsp = gd_val;

#ifdef YYLSP_NEEDED
  gd_lsp++;
  if (gd_len == 0)
    {
      gd_lsp->first_line = gd_lloc.first_line;
      gd_lsp->first_column = gd_lloc.first_column;
      gd_lsp->last_line = (gd_lsp-1)->last_line;
      gd_lsp->last_column = (gd_lsp-1)->last_column;
      gd_lsp->text = 0;
    }
  else
    {
      gd_lsp->last_line = (gd_lsp+gd_len-1)->last_line;
      gd_lsp->last_column = (gd_lsp+gd_len-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  gd_n = gd_r1[gd_n];

  gd_state = gd_pgoto[gd_n - YYNTBASE] + *gd_ssp;
  if (gd_state >= 0 && gd_state <= YYLAST && gd_check[gd_state] == *gd_ssp)
    gd_state = gd_table[gd_state];
  else
    gd_state = gd_defgoto[gd_n - YYNTBASE];

  goto gd_newstate;

gd_errlab:   /* here on detecting error */

  if (! gd_errstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++gd_nerrs;

#ifdef YYERROR_VERBOSE
      gd_n = gd_pact[gd_state];

      if (gd_n > YYFLAG && gd_n < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -gd_n if nec to avoid negative indexes in gd_check.  */
	  for (x = (gd_n < 0 ? -gd_n : 0);
	       x < (sizeof(gd_tname) / sizeof(char *)); x++)
	    if (gd_check[x + gd_n] == x)
	      size += strlen(gd_tname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (gd_n < 0 ? -gd_n : 0);
		       x < (sizeof(gd_tname) / sizeof(char *)); x++)
		    if (gd_check[x + gd_n] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, gd_tname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      gd_error(msg);
	      free(msg);
	    }
	  else
	    gd_error ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	gd_error("parse error");
    }

  goto gd_errlab1;
gd_errlab1:   /* here on error raised explicitly by an action */

  if (gd_errstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (gd_char == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (gd_debug)
	fprintf(stderr, "Discarding token %d (%s).\n", gd_char, gd_tname[gd_char1]);
#endif

      gd_char = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  gd_errstatus = 3;		/* Each real token shifted decrements this */

  goto gd_errhandle;

gd_errdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  gd_n = gd_defact[gd_state];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (gd_n) goto gd_default;
#endif

gd_errpop:   /* pop the current state because it cannot handle the error token */

  if (gd_ssp == gd_ss) YYABORT;
  gd_vsp--;
  gd_state = *--gd_ssp;
#ifdef YYLSP_NEEDED
  gd_lsp--;
#endif

#if YYDEBUG != 0
  if (gd_debug)
    {
      short *ssp1 = gd_ss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != gd_ssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

gd_errhandle:

  gd_n = gd_pact[gd_state];
  if (gd_n == YYFLAG)
    goto gd_errdefault;

  gd_n += YYTERROR;
  if (gd_n < 0 || gd_n > YYLAST || gd_check[gd_n] != YYTERROR)
    goto gd_errdefault;

  gd_n = gd_table[gd_n];
  if (gd_n < 0)
    {
      if (gd_n == YYFLAG)
	goto gd_errpop;
      gd_n = -gd_n;
      goto gd_reduce;
    }
  else if (gd_n == 0)
    goto gd_errpop;

  if (gd_n == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (gd_debug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++gd_vsp = gd_lval;
#ifdef YYLSP_NEEDED
  *++gd_lsp = gd_lloc;
#endif

  gd_state = gd_n;
  goto gd_newstate;
}
#line 366 "getdate.y"


/* Month and day table. */
static TABLE const MonthDayTable[] = {
    { "january",	tMONTH,  1 },
    { "february",	tMONTH,  2 },
    { "march",		tMONTH,  3 },
    { "april",		tMONTH,  4 },
    { "may",		tMONTH,  5 },
    { "june",		tMONTH,  6 },
    { "july",		tMONTH,  7 },
    { "august",		tMONTH,  8 },
    { "september",	tMONTH,  9 },
    { "sept",		tMONTH,  9 },
    { "october",	tMONTH, 10 },
    { "november",	tMONTH, 11 },
    { "december",	tMONTH, 12 },
    { "sunday",		tDAY, 0 },
    { "monday",		tDAY, 1 },
    { "tuesday",	tDAY, 2 },
    { "tues",		tDAY, 2 },
    { "wednesday",	tDAY, 3 },
    { "wednes",		tDAY, 3 },
    { "thursday",	tDAY, 4 },
    { "thur",		tDAY, 4 },
    { "thurs",		tDAY, 4 },
    { "friday",		tDAY, 5 },
    { "saturday",	tDAY, 6 },
    { NULL }
};

/* Time units table. */
static TABLE const UnitsTable[] = {
    { "year",		tMONTH_UNIT,	12 },
    { "month",		tMONTH_UNIT,	1 },
    { "fortnight",	tMINUTE_UNIT,	14 * 24 * 60 },
    { "week",		tMINUTE_UNIT,	7 * 24 * 60 },
    { "day",		tMINUTE_UNIT,	1 * 24 * 60 },
    { "hour",		tMINUTE_UNIT,	60 },
    { "minute",		tMINUTE_UNIT,	1 },
    { "min",		tMINUTE_UNIT,	1 },
    { "second",		tSEC_UNIT,	1 },
    { "sec",		tSEC_UNIT,	1 },
    { NULL }
};

/* Assorted relative-time words. */
static TABLE const OtherTable[] = {
    { "tomorrow",	tMINUTE_UNIT,	1 * 24 * 60 },
    { "yesterday",	tMINUTE_UNIT,	-1 * 24 * 60 },
    { "today",		tMINUTE_UNIT,	0 },
    { "now",		tMINUTE_UNIT,	0 },
    { "last",		tUNUMBER,	-1 },
    { "this",		tMINUTE_UNIT,	0 },
    { "next",		tUNUMBER,	2 },
    { "first",		tUNUMBER,	1 },
/*  { "second",		tUNUMBER,	2 }, */
    { "third",		tUNUMBER,	3 },
    { "fourth",		tUNUMBER,	4 },
    { "fifth",		tUNUMBER,	5 },
    { "sixth",		tUNUMBER,	6 },
    { "seventh",	tUNUMBER,	7 },
    { "eighth",		tUNUMBER,	8 },
    { "ninth",		tUNUMBER,	9 },
    { "tenth",		tUNUMBER,	10 },
    { "eleventh",	tUNUMBER,	11 },
    { "twelfth",	tUNUMBER,	12 },
    { "ago",		tAGO,	1 },
    { NULL }
};

/* The timezone table. */
/* Some of these are commented out because a time_t can't store a float. */
static TABLE const TimezoneTable[] = {
    { "gmt",	tZONE,     HOUR( 0) },	/* Greenwich Mean */
    { "ut",	tZONE,     HOUR( 0) },	/* Universal (Coordinated) */
    { "utc",	tZONE,     HOUR( 0) },
    { "wet",	tZONE,     HOUR( 0) },	/* Western European */
    { "bst",	tDAYZONE,  HOUR( 0) },	/* British Summer */
    { "wat",	tZONE,     HOUR( 1) },	/* West Africa */
    { "at",	tZONE,     HOUR( 2) },	/* Azores */
#if	0
    /* For completeness.  BST is also British Summer, and GST is
     * also Guam Standard. */
    { "bst",	tZONE,     HOUR( 3) },	/* Brazil Standard */
    { "gst",	tZONE,     HOUR( 3) },	/* Greenland Standard */
#endif
#if 0
    { "nft",	tZONE,     HOUR(3.5) },	/* Newfoundland */
    { "nst",	tZONE,     HOUR(3.5) },	/* Newfoundland Standard */
    { "ndt",	tDAYZONE,  HOUR(3.5) },	/* Newfoundland Daylight */
#endif
    { "ast",	tZONE,     HOUR( 4) },	/* Atlantic Standard */
    { "adt",	tDAYZONE,  HOUR( 4) },	/* Atlantic Daylight */
    { "est",	tZONE,     HOUR( 5) },	/* Eastern Standard */
    { "edt",	tDAYZONE,  HOUR( 5) },	/* Eastern Daylight */
    { "cst",	tZONE,     HOUR( 6) },	/* Central Standard */
    { "cdt",	tDAYZONE,  HOUR( 6) },	/* Central Daylight */
    { "mst",	tZONE,     HOUR( 7) },	/* Mountain Standard */
    { "mdt",	tDAYZONE,  HOUR( 7) },	/* Mountain Daylight */
    { "pst",	tZONE,     HOUR( 8) },	/* Pacific Standard */
    { "pdt",	tDAYZONE,  HOUR( 8) },	/* Pacific Daylight */
    { "yst",	tZONE,     HOUR( 9) },	/* Yukon Standard */
    { "ydt",	tDAYZONE,  HOUR( 9) },	/* Yukon Daylight */
    { "hst",	tZONE,     HOUR(10) },	/* Hawaii Standard */
    { "hdt",	tDAYZONE,  HOUR(10) },	/* Hawaii Daylight */
    { "cat",	tZONE,     HOUR(10) },	/* Central Alaska */
    { "ahst",	tZONE,     HOUR(10) },	/* Alaska-Hawaii Standard */
    { "nt",	tZONE,     HOUR(11) },	/* Nome */
    { "idlw",	tZONE,     HOUR(12) },	/* International Date Line West */
    { "cet",	tZONE,     -HOUR(1) },	/* Central European */
    { "met",	tZONE,     -HOUR(1) },	/* Middle European */
    { "mewt",	tZONE,     -HOUR(1) },	/* Middle European Winter */
    { "mest",	tDAYZONE,  -HOUR(1) },	/* Middle European Summer */
    { "swt",	tZONE,     -HOUR(1) },	/* Swedish Winter */
    { "sst",	tDAYZONE,  -HOUR(1) },	/* Swedish Summer */
    { "fwt",	tZONE,     -HOUR(1) },	/* French Winter */
    { "fst",	tDAYZONE,  -HOUR(1) },	/* French Summer */
    { "eet",	tZONE,     -HOUR(2) },	/* Eastern Europe, USSR Zone 1 */
    { "bt",	tZONE,     -HOUR(3) },	/* Baghdad, USSR Zone 2 */
#if 0
    { "it",	tZONE,     -HOUR(3.5) },/* Iran */
#endif
    { "zp4",	tZONE,     -HOUR(4) },	/* USSR Zone 3 */
    { "zp5",	tZONE,     -HOUR(5) },	/* USSR Zone 4 */
#if 0
    { "ist",	tZONE,     -HOUR(5.5) },/* Indian Standard */
#endif
    { "zp6",	tZONE,     -HOUR(6) },	/* USSR Zone 5 */
#if	0
    /* For completeness.  NST is also Newfoundland Stanard, and SST is
     * also Swedish Summer. */
    { "nst",	tZONE,     -HOUR(6.5) },/* North Sumatra */
    { "sst",	tZONE,     -HOUR(7) },	/* South Sumatra, USSR Zone 6 */
#endif	/* 0 */
    { "wast",	tZONE,     -HOUR(7) },	/* West Australian Standard */
    { "wadt",	tDAYZONE,  -HOUR(7) },	/* West Australian Daylight */
#if 0
    { "jt",	tZONE,     -HOUR(7.5) },/* Java (3pm in Cronusland!) */
#endif
    { "cct",	tZONE,     -HOUR(8) },	/* China Coast, USSR Zone 7 */
    { "jst",	tZONE,     -HOUR(9) },	/* Japan Standard, USSR Zone 8 */
#if 0
    { "cast",	tZONE,     -HOUR(9.5) },/* Central Australian Standard */
    { "cadt",	tDAYZONE,  -HOUR(9.5) },/* Central Australian Daylight */
#endif
    { "east",	tZONE,     -HOUR(10) },	/* Eastern Australian Standard */
    { "eadt",	tDAYZONE,  -HOUR(10) },	/* Eastern Australian Daylight */
    { "gst",	tZONE,     -HOUR(10) },	/* Guam Standard, USSR Zone 9 */
    { "nzt",	tZONE,     -HOUR(12) },	/* New Zealand */
    { "nzst",	tZONE,     -HOUR(12) },	/* New Zealand Standard */
    { "nzdt",	tDAYZONE,  -HOUR(12) },	/* New Zealand Daylight */
    { "idle",	tZONE,     -HOUR(12) },	/* International Date Line East */
    {  NULL  }
};

/* Military timezone table. */
static TABLE const MilitaryTable[] = {
    { "a",	tZONE,	HOUR(  1) },
    { "b",	tZONE,	HOUR(  2) },
    { "c",	tZONE,	HOUR(  3) },
    { "d",	tZONE,	HOUR(  4) },
    { "e",	tZONE,	HOUR(  5) },
    { "f",	tZONE,	HOUR(  6) },
    { "g",	tZONE,	HOUR(  7) },
    { "h",	tZONE,	HOUR(  8) },
    { "i",	tZONE,	HOUR(  9) },
    { "k",	tZONE,	HOUR( 10) },
    { "l",	tZONE,	HOUR( 11) },
    { "m",	tZONE,	HOUR( 12) },
    { "n",	tZONE,	HOUR(- 1) },
    { "o",	tZONE,	HOUR(- 2) },
    { "p",	tZONE,	HOUR(- 3) },
    { "q",	tZONE,	HOUR(- 4) },
    { "r",	tZONE,	HOUR(- 5) },
    { "s",	tZONE,	HOUR(- 6) },
    { "t",	tZONE,	HOUR(- 7) },
    { "u",	tZONE,	HOUR(- 8) },
    { "v",	tZONE,	HOUR(- 9) },
    { "w",	tZONE,	HOUR(-10) },
    { "x",	tZONE,	HOUR(-11) },
    { "y",	tZONE,	HOUR(-12) },
    { "z",	tZONE,	HOUR(  0) },
    { NULL }
};




/* ARGSUSED */
static int
gd_error(s)
    char	*s;
{
  return 0;
}

#define ToTOD(Hours, Minutes, Seconds, Meridian)	\
     ( ToSeconds(Hours, Minutes, Seconds, Meridian) / SECSPERDAY )

double ToSeconds(Hours, Minutes, Seconds, Meridian)
    int	Hours;
    int	Minutes;
    int	Seconds;
    MERIDIAN	Meridian;
{
    if (Minutes < 0 || Minutes > 59 || Seconds < 0 || Seconds > 59)
	return -1.0;
    switch (Meridian) {
    case MER24:
	if (Hours < 0 || Hours > 23)
	    return -1.0;
	return (Hours * 60L + Minutes) * 60L + Seconds;
    case MERam:
	if (Hours < 1 || Hours > 12)
	    return -1.0;
	return (Hours * 60L + Minutes) * 60L + Seconds;
    case MERpm:
	if (Hours < 1 || Hours > 12)
	    return -1.0;
	return ((Hours + 12) * 60L + Minutes) * 60L + Seconds;
    }
    /* NOTREACHED */
}


static double
Convert(Month, Day, Year, Hours, Minutes, Seconds, Meridian, DSTmode)
    int	Month;
    int	Day;
    int	Year;
    int	Hours;
    int	Minutes;
    int	Seconds;
    MERIDIAN	Meridian;
    DSTMODE	DSTmode;
{
    double	Julian;
    double	tod;
    int		j;
    time_t	unx;

    if (Year <   0) Year = -Year;
    if (Year <  50) Year += 2000;
    if (Year < 100) Year += 1900;

    slaCldj(Year, Month, Day, &Julian, &j);
    if ( j ) return -1;
    Julian += ((double ) gd_Timezone * 60L) / SECSPERDAY;

    if ((tod = ToTOD(Hours, Minutes, Seconds, Meridian)) < 0)
	return -1;
    else
    	Julian += tod;


    if ( Julian >= MJD1970 ) {
	unx = MJDtoUNIXTIME(Julian);

	if (DSTmode == DSTon
	 || (DSTmode == DSTmaybe && localtime(&unx)->tm_isdst))
	    Julian -= ((double) (60 * 60)) / SECSPERDAY;
    }

    return Julian;
}


static time_t
DSTcorrect(Start, Future)
    time_t	Start;
    time_t	Future;
{
    time_t	StartDay;
    time_t	FutureDay;

    StartDay = (localtime(&Start)->tm_hour + 1) % 24;
    FutureDay = (localtime(&Future)->tm_hour + 1) % 24;
    return (Future - Start) + (StartDay - FutureDay) * 60L * 60L;
}


static double
RelativeDate(Start, DayOrdinal, DayNumber)
    double	Start;
    time_t	DayOrdinal;
    time_t	DayNumber;
{
    struct tm	*tm;
    time_t	unx;
    time_t	now;

    if ( Start >= MJD1970 ) {
	unx = MJDtoUNIXTIME(Start);

	tm = localtime(&unx);
	now += SECSPERDAY * ((DayNumber - tm->tm_wday + 7) % 7);
	now += 7 * SECSPERDAY * (DayOrdinal <= 0 ? DayOrdinal : DayOrdinal - 1);
	return ((double) DSTcorrect(unx, now)) / SECSPERDAY;
    }

    return 0.0;
}


static double
RelativeMonth(Start, RelMonth)
    double	Start;
    time_t	RelMonth;
{
    struct tm	*tm;
    time_t	Month;
    time_t	Year;
    time_t	unx;
    double	mjd;
    time_t	now;

    if (RelMonth == 0 || Start < MJD1970 )
	return 0.0;

    unx = MJDtoUNIXTIME(Start);
    
    tm = localtime(&unx);
    Month = 12 * tm->tm_year + tm->tm_mon + RelMonth;
    Year = Month / 12;
    Month = Month % 12 + 1;
    mjd = Convert(Month, (time_t)tm->tm_mday, Year,
	(time_t)tm->tm_hour, (time_t)tm->tm_min, (time_t)tm->tm_sec,
	MER24, DSTmaybe);

    now = MJDtoUNIXTIME(mjd);

    return ((double) DSTcorrect(unx, now)) / SECSPERDAY;
}


static int
LookupWord(buff)
    char		*buff;
{
    register char	*p;
    register char	*q;
    register const TABLE	*tp;
    int			i;
    int			abbrev;

    /* Make it lowercase. */
    for (p = buff; *p; p++)
	if (isupper(*p))
	    *p = tolower(*p);

    if (strcmp(buff, "am") == 0 || strcmp(buff, "a.m.") == 0) {
	gd_lval.Meridian = MERam;
	return tMERIDIAN;
    }
    if (strcmp(buff, "pm") == 0 || strcmp(buff, "p.m.") == 0) {
	gd_lval.Meridian = MERpm;
	return tMERIDIAN;
    }

    /* See if we have an abbreviation for a month. */
    if (strlen(buff) == 3)
	abbrev = 1;
    else if (strlen(buff) == 4 && buff[3] == '.') {
	abbrev = 1;
	buff[3] = '\0';
    }
    else
	abbrev = 0;

    for (tp = MonthDayTable; tp->name; tp++) {
	if (abbrev) {
	    if (strncmp(buff, tp->name, 3) == 0) {
		gd_lval.Number = tp->value;
		return tp->type;
	    }
	}
	else if (strcmp(buff, tp->name) == 0) {
	    gd_lval.Number = tp->value;
	    return tp->type;
	}
    }

    for (tp = TimezoneTable; tp->name; tp++)
	if (strcmp(buff, tp->name) == 0) {
	    gd_lval.Number = tp->value;
	    return tp->type;
	}

    if (strcmp(buff, "dst") == 0) 
	return tDST;

    for (tp = UnitsTable; tp->name; tp++)
	if (strcmp(buff, tp->name) == 0) {
	    gd_lval.Number = tp->value;
	    return tp->type;
	}

    /* Strip off any plural and try the units table again. */
    i = strlen(buff) - 1;
    if (buff[i] == 's') {
	buff[i] = '\0';
	for (tp = UnitsTable; tp->name; tp++)
	    if (strcmp(buff, tp->name) == 0) {
		gd_lval.Number = tp->value;
		return tp->type;
	    }
	buff[i] = 's';		/* Put back for "this" in OtherTable. */
    }

    for (tp = OtherTable; tp->name; tp++)
	if (strcmp(buff, tp->name) == 0) {
	    gd_lval.Number = tp->value;
	    return tp->type;
	}

    /* Military timezones. */
    if (buff[1] == '\0' && isalpha(*buff)) {
	for (tp = MilitaryTable; tp->name; tp++)
	    if (strcmp(buff, tp->name) == 0) {
		gd_lval.Number = tp->value;
		return tp->type;
	    }
    }

    /* Drop out any periods and try the timezone table again. */
    for (i = 0, p = q = buff; *q; q++)
	if (*q != '.')
	    *p++ = *q;
	else
	    i++;
    *p = '\0';
    if (i)
	for (tp = TimezoneTable; tp->name; tp++)
	    if (strcmp(buff, tp->name) == 0) {
		gd_lval.Number = tp->value;
		return tp->type;
	    }

    return tID;
}

TZX() {
#if HAVE_DYSIZE
        time_t  unx;
        struct tm *tmx;
        ctime(&unx);
        tmx = localtime(&unx);
        return tmx->tm_gmtoff;
#else
	return timezone;
#endif
}
	

static int
gd_lex()
{
    register char	c;
    register char	*p;
    char		buff[20];
    int			Count;
    int			sign;

    for ( ; ; ) {
	while (isspace(*gd_Input))
	    gd_Input++;

	if (isdigit(c = *gd_Input) || c == '-' || c == '+') {
	    if (c == '-' || c == '+') {
		sign = c == '-' ? -1 : 1;
		if (!isdigit(*++gd_Input))
		    /* skip the '-' sign */
		    return '-';
	    }
	    else
		sign = 0;
	    for (gd_lval.Number = 0; isdigit(c = *gd_Input++); )
		gd_lval.Number = 10 * gd_lval.Number + c - '0';
	    gd_Input--;
	    if (sign < 0)
		gd_lval.Number = -gd_lval.Number;
	    return sign ? tSNUMBER : tUNUMBER;
	}
	if (isalpha(c)) {
	    for (p = buff; isalpha(c = *gd_Input++) || c == '.'; )
		if (p < &buff[sizeof buff - 1])
		    *p++ = c;
	    *p = '\0';
	    gd_Input--;
	    return LookupWord(buff);
	}
	if (c != '(')
	    return *gd_Input++;
	Count = 0;
	do {
	    c = *gd_Input++;
	    if (c == '\0')
		return c;
	    if (c == '(')
		Count++;
	    else if (c == ')')
		Count--;
	} while (Count > 0);
    }
}


/* Return the MJD as a double.
 */
double mjd(p, now, gmt)
    char		*p;
    double		 now;
    int			 gmt;
{
    struct tm		*tptr;
    double		Start;
    double		tod;

    int	day, month, year, hour, min, sec, j;

    gd_Input = p;
    if ( now == -1.0 ) {
		time_t tnow;

	time(&tnow);
	if ( !gmt ) {
    	    tzset();
	    tptr = localtime(&tnow);
	} else
	    tptr = gmtime(&tnow);

	slaCldj(tptr->tm_year + 1900, tptr->tm_mon + 1, tptr->tm_mday
		, &now, &j);
	if ( j ) return -1;

	if ( (tod = ToTOD(tptr->tm_hour, tptr->tm_min, tptr->tm_sec, MER24)) 
		< 0)
	    return -1;
    }

    now += tod;
    slaDjcl(now, &year, &month, &day, &tod, &j);
    if ( j ) return -1;

    gd_Year = year;
    gd_Month = month;
    gd_Day = day;
    gd_Timezone = gmt ? 0 : TZX() / 60L;	/* In minutes	*/
    gd_DSTmode  = gmt ? DSToff : DSTmaybe;
    gd_Hour = 0;
    gd_Minutes = 0;
    gd_Seconds = 0;
    gd_Meridian = MER24;
    gd_RelSeconds = 0;
    gd_RelMonth = 0;
    gd_HaveDate = 0;
    gd_HaveDay = 0;
    gd_HaveRel = 0;
    gd_HaveTime = 0;
    gd_HaveZone = 0;

    if (gd_parse()
     || gd_HaveTime > 1 || gd_HaveZone > 1 || gd_HaveDate > 1 || gd_HaveDay > 1)
	return -1;

    if (gd_HaveDate || gd_HaveTime || gd_HaveDay) {
	Start = Convert(gd_Month, gd_Day, gd_Year, gd_Hour, gd_Minutes, gd_Seconds,
		    gd_Meridian, gd_DSTmode);
	if (Start < 0)
	    return -1;
    }
    else {
	Start = now;
	if (!gd_HaveRel)
	    Start -= tod; 
    }

    Start += ((double) gd_RelSeconds) / SECSPERDAY;

    if ( gd_RelMonth ) 
	if ( Start < MJD1970 ) return -1;
    	else
	    Start += RelativeMonth(Start, gd_RelMonth);

    if (gd_HaveDay && !gd_HaveDate) {
	if ( Start < MJD1970 ) return -1;
	else
	    Start += RelativeDate(Start, gd_DayOrdinal, gd_DayNumber);
    }

    return Start;
}

char *cal(buffer, max, mjd, format)
	char	*buffer;
	int	 max;
	double	 mjd;
	char	*format;
{
	struct   tm tstc;
	struct   tm*tstp = &tstc;

	if ( !format ) format = "%a %b %e %T %Y";

	if ( mjd >= MJD1970 ) {
		time_t unx = MJDtoUNIXTIME(mjd);

	    tstp = gmtime(&unx);
	} else {
		int	 iy, im, id, j;
		double	 fd;

	    tstc.tm_mday = -1;
	    tstc.tm_wday = -1;
	    tstc.tm_yday = -1;

	    slaDjcl(mjd, &iy, &im, &id, &fd, &j);

	    tstc.tm_year = iy - 1900;
	    tstc.tm_mon  = im - 1;
	    tstc.tm_mday = id;
	    tstc.tm_hour =  ((int) fd / 24) * 24;
	    tstc.tm_min  = (((int) ((fd - tstc.tm_hour) / 60) * 60) + .5);
	    tstc.tm_sec  = ((int) (((fd - (tstc.tm_hour + tstc.tm_min))
			    / 60 * 60 ) * 60 * 60) + .5);
	    if ( tstc.tm_sec >= 60 ) { tstc.tm_sec = 0; tstc.tm_min++;  }
	    if ( tstc.tm_min >= 60 ) { tstc.tm_min = 0; tstc.tm_hour++; }

	    tstc.tm_isdst = 0;
	}

	strftime(buffer, max, format, tstp);

	return buffer;
}


#if	defined(TEST)

/* ARGSUSED */
main(ac, av)
    int		ac;
    char	*av[];
{
    char	buff[128];
    time_t	d;

    (void)printf("Enter date, or blank line to exit.\n\t> ");
    (void)fflush(stdout);
    while (gets(buff) && buff[0]) {
	d = get_date(buff, (struct timeb *)NULL);
	if (d == -1)
	    (void)printf("Bad format - couldn't convert.\n");
	else
	    (void)printf("%s", ctime(&d));
	(void)printf("\t> ");
	(void)fflush(stdout);
    }
    exit(0);
    /* NOTREACHED */
}
#endif	/* defined(TEST) */
