c*** File iolib/lopen.f
c*** January 24, 1996
c*** By Doug Mink

c--- Open logging file

	Subroutine LOPEN (FNAME,IOP)

	Character*(*) FNAME
c			File name to replace standard output
c			If STDOUT or stdout, output without CR's
	Integer*4 IOP
c			-3 or 0 > file and standard output
c			-1 or 1 > file only
c			-2 or 2 > file and standard output if Tektronix compatible
c			if negative, append to file instead of starting it fresh

	Character*64 FNAME0
	Common/PLF/ IFIP,IOPT
	Integer*4 IFIP, IOPT

	IOPT = 0
	IFIP = 0
	If (FNAME(1:1) .eq. Char (0)) Return
	If ((IOP.eq.4) .or. (FNAME(1:5).eq.'stdout') .or.
     1	    (FNAME(1:5).eq.'STDOUT')) Then
	    IOPT = 4
	    IFIP = 1
	    Return
	    Endif

	IOPT = Iabs (IOP)
	If (IOPT .gt. 2) IOPT = 0

	IFIP = -2
	If (IOP .ge. 0) Then
	   Call FOPENW (IFIP,FNAME)
	Else
	   Call FOPENA (IFIP,FNAME)
	Endif

c  Write to /tmp directory if file cannot be created locally

	If (IFIP .eq. -2) Then
	    FNAME0 = '/tmp/'
	    Call CONSTR (FNAME0,FNAME)
	    FNAME = FNAME0	
	    If (IOP .ge. 0) Then
		Call FOPENW (IFIP,FNAME)
	    Else
		Call FOPENA (IFIP,FNAME)
	    Endif
	    Endif

	If (IOPT .eq. 2) Call GETTERM

	If (IFIP .le. 2) IFIP = 1

	Return
	End

c Oct 25 1984	Use stream (buffered) output instead of normal output
c Nov  7 1984	Make writing to standard output optional
c Dec  7 1984	Add option of appending to plot file

c Jan 16 1985	If NULL filename, don't open an output file
c Feb 27 1985	Add option to append to option 0 file

c Apr 27 1988	Set terminal capabilities if IOPT is 2

c Nov  9 1990	Autoset to file only if log file is "stdout"

c Feb 22 1993	Declare undeclared variables ifip and iopt

c Jan 24 1996	If logfile is not writeable, write to file in /tmp
