c*** File iolib/makepath.f
c*** November 30, 1995
c*** By Doug Mink

	Subroutine MAKEPATH (DIRPATH,FILENAME,FILEPATH)

c--- Make file path name from directory path name and file name
c   * If a / is detected within the file name, it is assumed to already
c     be a full  pathname and is returned in FILEPATH.

	Character*(*) DIRPATH
c				Directory path name
	Character*(*) FILENAME
c				File name within directory
	Character*(*) FILEPATH
c				File path name

c  If file name is already a complete pathname, return

	If (FILENAME(1:1) .eq. '/') Then
	    FILEPATH = FILENAME

c  If directory pathname is not complete, return

	Elseif (Index (DIRPATH,'/') .le. 0) Then
	    FILEPATH = FILENAME

c  In all other cases, append file name to directory path

	Else
	    FILEPATH = DIRPATH
	    Call PADNULL (FILEPATH)
	    Call CONSTR (FILEPATH,'/')
	    Call CONSTR (FILEPATH,FILENAME)
	Endif

	Call PADNULL (FILEPATH)

	Return
	End

c Nov 21 1985	Always pad FILEPATH, not just when CONCATting

c Apr  9 1987	Use new concatenation subroutine CONSTR
c Jun 17 1987	Use '/' instead of '/$' (VLEN fixed)

c Jan 22 1988	Replace PADSTR call with PADNULL

c May 17 1993	Treat filename as pathname only if it starts with /

c Oct  3 1995	Upsize filepath from 64 to 128
c Nov 30 1995	Make filepath (*), as it should have been all along
