c*** File iolib/opentab.f
c*** July 27, 2004
c*** By Doug Mink

	Subroutine OPENRTAB (IFD, PARMS, FNAME)

c--- Open a tab table file for reading

	Integer*4 IFD
c			UNIX file descriptor (returned)
c			If =-2 on entry, there will be no printed error
c			messages, and IFD will be unchanged on return.
	Character*(*) PARMS
c			ASCII parameter string
	Character*(*) FNAME
c			Null-terminated file pathname
c			If error condition arises and IFD is not =-2, this
c			subroutine will request a new file name from the user.

	Integer*4 IER, LFN, NR
	Character*1000 LINE, LINE1
	Integer*4 ICOL, NCMAX, NCOL, COL1(200), COL2(200)
	Character*16 TNAME

	NCMAX = 200

c  Open file for reading

	IFD = -2
	Call FOPENR (IFD,FNAME)
	Call VLEN (FNAME,LFN)
	If (IFD .lt. 0) Then
	    Write(*,10) FNAME(1:LFN)
10	    Format('*** OPENRTAB: File "',A,'" is not readable')
	    Return
	    Endif

c  Read to header

100	Call SFGETL (IFD, LINE, NR)
	If (NR .lt. 0) Then
	    Write(*,110) FNAME(1:LFN)
110	    Format('*** OPENRTAB: File "',A,'" is not a tab table: no ---')
	    Call SFCLOSE (IFD,IER)
	    IFD = -2
	    Return
	    Endif

	If (LINE(1:1) .ne. '-') Then
	    LINE1 = LINE
	    Go to 100
	    Endif

c  Read column headers

	Call SETOKEN (LINE1, NCMAX, 'TAB', NCOL, COL1, COL2)

	If (NCOL .lt. 1) Then
	    Write(*,120) FNAME(1:LFN)
120	    Format('*** OPENRTAB: File "',A,'" is not a tab table: no headers')
	    Call SFCLOSE (IFD,IER)
	    IFD = -2
	    Return
	    Endif

	Call PPUTI4 (PARMS,'NCOL',NCOL)
	Do ICOL = 1, NCOL
	    Call PNAME ('COLHEAD',ICOL,TNAME)
	    Call PPUTS (PARMS,TNAME,LINE1(COL1(ICOL):COL2(ICOL)))
	    Enddo
	Call PNAME ('COLHEAD',NCOL+1,TNAME)
	Call PPUTS (PARMS,TNAME,'-')

	Return
	End
c Oct 17 1995	New subroutine
c Nov 24 1995	Declare undeclared variable nr

c Jul 27 2004	Increase maximum number of columns from 100 to 200
c Jul 27 2004	Increase line length from 500 to 1000
