c*** File iolib/pararg.f
c*** December 1, 2004
c*** By Doug Mink, Center for Astrophysics

c--- Set parameters from command line assignment arguments

	Subroutine PARARG (PARMS)

	Character*(*) PARMS
c				Parameter string to run calling program

	Character*64 PARMFILE
c				Parameter file for calling program
	Character*64 ARGUMENT
c				Single command line argument
	Logical DIAG,ASSIGN,PARVAL,LIST
	Integer*4 NARG,IARG,LARG,Iargc

	Include 'constants.cmb'

	Call PGETL (PARMS,'DIAG',DIAG)
	Call HVERB (DIAG)
	Call PGETC (PARMS,'PARMFILE',PARMFILE)
	PARVAL = .false.
	Call PGETL (PARMS,'PARVAL',PARVAL)

c  Loop through argument list

	NARG = Iargc ()
	IARG = 0
100	Call NEXTARG (IARG,NARG,ARGUMENT,LARG)
	If (LARG .lt. 1) Go to 900

c  Evaluate command line assignments or list parameter values

	ASSIGN = .false.
	LIST = PARVAL
	Call PSET (PARMS,ARGUMENT,LIST,ASSIGN)
	If (ASSIGN) Then
	    If (LIST) Then
		If (IARG .eq. NARG) Then
		    Call PNEWLINE
		    Stop
		Else
		    If (PARVAL) Call PCHRS (1,Char(9))
		    Go to 100
		Endif
	    Else
		Call PWRITE (PARMFILE,PARMS)
		Go to 100
	    Endif

c  Skip parameter file argument

	Elseif (ARGUMENT(1:4) .eq. '-par') Then
	    Call NEXTARG (IARG,NARG,ARGUMENT,LARG)
	    If (LARG .lt. 1) Go to 900

c  Verbose switch

	Elseif (ARGUMENT(1:2) .eq. '-v') Then
	    DIAG = .true.
	    Call HVERB (DIAG)
	    Call PPUTL (PARMS,'DIAG',DIAG)
	Elseif (ARGUMENT(1:3) .eq. '-nv') Then
	    DIAG = .false.
	    Call HVERB (DIAG)
	    Call PPUTL (PARMS,'DIAG',DIAG)

	Elseif (ARGUMENT(1:5) .eq. '-stop') Then
	    If (DIAG) Write(*,*) 'Updating parameter file only'
	    Stop

	Elseif (ARGUMENT(1:4) .eq. 'stop') Then
	    If (DIAG) Write(*,*) 'Updating parameter file only'
	    Stop
	Endif
	Call PWRITE (PARMFILE,PARMS)
	Go to 100

900	Return
	End
c May 19 1995	New subroutine
c Jun 21 1995	Skip parameter file argument

c Dec  1 2004	Include only from local directory
