c*** File iolib/pwrite.f
c*** May 27, 1993
c*** By Doug Mink

c--- Write FITS-like parameter string to parameter file
c    Note settings of /HEADER/ common.

	Subroutine PWRITE (FNAME,HSTRING)

	Character*(*) FNAME
c			File name
	Character*(*) HSTRING
c			Header string

	Integer*4 IFIL
c			UNIX file to which to write (returned)
	Integer*4 NC
c			Number of characters in header string

	Integer*4 IEND,IER,LFN,N,NW,NWRIT,LTEMP
	Character*20 TEMP

	Include 'header.cmb'

c  Compute number of bytes to write

	Call PSEARCH (HSTRING,'END',IEND,N)
	If (IEND .lt. 1) Then
	    Write(*,*) 'PWRITE: No END found in parameter string'
	    Write(*,*) '***  Parameter string not written to file ***'
	    Return
	    Endif
	NC = IEND + 3
	HSTRING(NC:NC) = Char (10)
	NW = NC

c  Open data file

	IFIL = -2
	Call OPENW (IFIL,FNAME)
	If (IFIL .lt. 3) Then
	    Call BINASCI4 (IFIL,TEMP)
	    Call VLEN (TEMP,LTEMP)
	    Call VLEN (FNAME,LFN)
	    Write(*,103) FNAME(1:LFN),TEMP(1:LTEMP)
103	    Format('PWRITE: File "',A,'" not writeable (',A,')')
	    Write(*,*) '******  Parameter string not written to file ******'
	    Return
	    Endif

c  Write FITS header

	Call SPUTC (IFIL,NW,HSTRING,NWRIT)
	If (NWRIT .lt. NW) Then
	    Write(*,105) NWRIT,NW,FNAME
105	    Format('PWRITE:',I5,'/',I5,' bytes written to "',A,'"')
	    Call PCHRS (1,Char(13))
	    Return
	    Endif

c  Truncate file to length of string

	Call STRUNC (IFIL,NC)

	If (VERBOSE) Write(*,110) NC,FNAME
110	Format('PWRITE:',I5,'-byte header written to file "',A,'"')

	Call SCLOSE (IFIL,IER)

	Return
	End

c Aug 12 1987	Add error handling if parameter string cannot be written

c Oct  5 1990	Fix minor error using flint

c Feb 22 1993	Declare undeclared variables iend,ier,lfn,n,nw,nwrit
c May 27 1993	Add more information to error messages
