/*** File iolib/sdelfile.c
 *** May 20, 1998
 *** By Doug Mink
 */

void
sdelfile_ (path,ier,nc)

/*   Delete file (Fortran-callable)
 *
 *	Call SDELFILE (PATH,IER) from Fortran
 *
 *	Character*(*) PATH
 *			Address of null-terminated file name (=path name)
 *	Integer*4 IER
 *			Address of error number (0=success)
 *
 *	nc	Number of characters in string PATH
 *		* this is not explicitly in the calling argument list;
 *		* Fortran puts it there
 */

char *path;
int *ier;
int nc;

{
    int err;
    extern int errno;

    /* Delete file */
    err = unlink (path);

    /* Set returned file descriptor */
    if (err == 0) *ier = 0;
    else *ier = errno;
	
    return;
}
/* Mar  7 1991	New subroutine
 *
 * May 20 1998	Declare void
 */
