/*** File /usr/rgf/test/sfput.c
 *** 8/15/84
 *** Dick French
 */

#include <sys/file.h>
#include </usr/include/stdio.h>

sfput_ (idev,nbytes,buf,nwrit)

/*   Write to UNIX file (Fortran-callable) using buffered I/O.  
 *
 *   Fortran calling sequence :  call sfput(idev,nbytes,buf,nwrit)
 *
 *	idev	Address of UNIX file descriptor (input)
 *
 *	nbytes	Address of number of bytes to write (input)
 *
 *	buf	Address of buffer array (input values to write to file)
 *
 *	nwrit	Address of number of bytes written (returned, should=nbytes)
 *   
 *   Subroutines called :  system utility fwrite 
 *
 *   Bugs and restrictions : VAX system routine used
 *
 *   See also : UNIX manual FREAD(3S)
 *              sfget.man
 *
 *   Revisions :  none
 */

char *buf;
int *nbytes,*nwrit;
int *idev;

{
FILE *stream;
int nw,nitems,size;

	nitems = *nbytes ;
	size = 1;
	stream = (FILE*)*idev;
	nw = fwrite(buf,size,nitems,stream);
	*nwrit = nw;
	
	return;
}
