/*** File sputl.c
 *** December 4, 1985
 *** By Doug Mink
 */
#include <sys/file.h>
#include<stdio.h>

sfputl_ (dev,buf,nc)

/*   Write one line to UNIX file (Fortran-callable)
 *
 *   Fortran calling sequence : Call SFPUTL (DEV,BUF)
 *
 *	DEV	Address of UNIX file descriptor (input)
 *		Integer*4
 *
 *	BUF	Address of buffer array (values returned)
 *		Character*(*)
 *
 *	nc	Number of characters in string buf
 *		* This is not explicitly in the calling argument list;
 *		* Fortran puts it there all by itself.
 */
char *buf;
int *dev,nc;
{
FILE *stream;
char c[2];

	/* write null-terminated string */

	stream = (FILE*)*dev;
	fputs (buf,stream);

	/* add newline */

	c[0] = 10;
	c[1] = 0;
	fputs (c,stream);

	return;
}
