/*** File iolib/sget.c
 *** March 30, 1986
 *** By Doug Mink
 */

sget_ (dev,nbytes,buf,nread)

/*   Read from UNIX file (Fortran-callable)
 *
 *	dev	Address of UNIX file descriptor
 *
 *	nbytes	Address of number of bytes to read
 *
 *	buf	Address of buffer array (values returned)
 *
 *	nread	Address of number of bytes read (value returned)
 */
char *buf;
int *nbytes,*dev,*nread;
{
int idev,nb,nr;
extern int errno;

	idev = *dev;
	nb = *nbytes;
	nr = read (idev,buf,nb);

	if (nr > -1) *nread = nr;
	else *nread = -errno;

	return;
}
