/*** File /usr/djm/iolib/slseek.c
 *** August 24, 1984
 *** By Doug Mink
 */

slseek_ (dev,offset,whence,pos)

/*   Position UNIX file pointer (Fortran-callable)
 *   (See LSEEK(2) in UNIX Programmer's Manual)
 *
 *	dev	Address of UNIX file descriptor
 *		Integer*4
 *
 *	offset	Address of number of bytes to offset
 *		Integer*4
 *
 *	whence	Address of pointer extension type
 *		0 > set to offset, 1 > current+offset, 2 > end+offset
 *		Integer*4
 *
 *	pos	Address of file pointer (returned; should = offset)
 *		Integer*4
 */
int *dev,*offset,*whence,*pos;
{
int idev;
	idev = *dev;
	*pos = lseek (idev,*offset,*whence);
	return;
}
