/*** File iolib/vecadd4.c
 *** June 15, 1988
 *** By Doug Mink, Center for Astrophysics
 */

vecadd4_ (vec4,lvec,nadd)

/*   add constant to vector of 4-byte integers
 *
 *	vec4	Address of output Integer*4 vector
 *
 *	lvec	Address of number of elements in vector
 *
 *	nadd	Address of number to add to vector
 */

int *vec4;
int *lvec;
int *nadd;

{
int *v4, *veclast;

	v4 = vec4 - 1;
	veclast = v4 + *lvec;

	if (*nadd > 0) {
	    while (v4++ < veclast) { *v4 = *v4 + *nadd; } }
	
	return;
}
