/*** File iolib/vecr2.c
 *** June 4, 1996
 *** By Doug Mink, Center for Astrophysics
 */

vecr2_ (vecr,vec2,lvec)

/*   Move vector of 4-byte integers into 2-byte integers
 *
 *	vecr	Address of input Real*4 vector
 *
 *	vec2	Address of output Integer*2 vector
 */

float *vecr;
int *lvec;
short *vec2;

{
unsigned int v;
float vrs,*vr, *veclast;
short *v2, v2i;

	vr = vecr;
	v2 = vec2;
	veclast = vr + *lvec + 1;

	while (vr < veclast) {
	    vrs = *vr++;
	    if (vrs > 32767.0) vrs = 32767.0;
	    else if (vrs < -32768.0) vrs = -32768.0;
	    *v2++ = (short) vrs;
	    }
	
	return;
}
