c*** File fitslib/hdel.f
c*** June 12, 1992
c*** By Doug Mink

c  Delete line for variable VNAME from FITS header string HSTRING

	Subroutine HDEL (HSTRING,VNAME)

	Character*(*) HSTRING
c		Character string containing FITS-style header information
c		in the format <VNAME>= <value> {/ <comment>}
c		Each Entry is padded with spaces to 80 characters

	Character*(*) VNAME
c		Character string containing the name of the variable
c		to be returned.  HPUT searches for a line beginning
c		with this string, and if it doesn't find one, creates one.
c		(THE FIRST 8 CHARACTERS OF A VARIABLE NAME MUST BE UNIQUE)

	Integer*4 L0,LE,L1,I

	Include 'header.cmb'

	FOUND = .false.

c  Search header string for variable name

	Call HSEARCH (HSTRING,VNAME,L0)

c  Find END of header

	Call HSEARCH (HSTRING,'END',LE)

c  If parameter is found, shift header back one line
c  and replace last line with spaces

	If (L0 .gt. 0) Then
	    L1 = LE - 1
	    HSTRING(L0:L1) = HSTRING(L0+80:LE+79)
	    Do 10 I = LE, LE+79, 10
10		HSTRING(I:I+9) = '          '
	    Endif

	Return
	End
