c*** File iolib/getterm.f
c*** February 22, 1993
c*** By Doug Mink

	Subroutine GETTERM

c--- Get terminal type (termcap entry name) from shell environment TERM

	Character NULL*1,TNAME*10
	Integer*4 I

	Include 'term.cmb'

	NULL = Char (0)

	Call Getenv ('TERM',TNAME)

	Do 10 I = 1, 12
10	   TTERM(I:I) = NULL
	TTERM = TNAME(1:6)
	If (TNAME(1:6) .eq. 'aed512') TTERM = 'aed'
	If (TNAME(1:3) .eq. 'tek') TTERM = 'tek'
c	Write(*,*) 'Terminal is ',TTERM

	If (TTERM(1:3).eq.'tek') ITEK = .true.
	If (TTERM(1:5).eq.'vs100') ITEK = .true.
c	If (TTERM(1:5).eq.'xterm') ITEK = .true.

	Return
	End

c Aug  3 1984	Get terminal name from call to Getenv, rather than
c		System call piped to file which is read; now much cleaner.
c Aug  6 1984	No longer set ITEK to .false. automatically; GETTERM
c		can now be called at any time (i.e. from ERASE) without
c		unneccessarily resetting anything.
c Nov 14 1984	Add vs100t (vs100 Tektronix emulator) to possibilities
c		for ITEK = .true.

c Feb 15 1985	Assume that any vs100 can handle Tektronix commands, even
c		though that's not really true.
c Jul 10 1985	Add xterm (new terminal emulator for Vs100 and QVSS)

c Dec 28 1990	Eliminate unused variables

c Feb 22 1993	Declare undeclared variable i 
