c*** File iolib/hvset.f
c*** February 22, 1993
c*** By Doug Mink

	Subroutine HVSET (CSTRING,HEADER)

c--- Insert or replace FITS-style header parameters

	Character*(*) CSTRING
c				New parameter list
c				(Packed FITS format, NULL, ;  or LF terminated lines
	Character*(*) HEADER
c				FITS header

	Character*1 JLF,NULL
c				Linefeed, null
	Character*100 LINE
c				One line of CSTRING
	Character*80 TEMP
c				Value of parameter on LINE as ASCII string
	Character*100 STRING
c				Value of parameter on LINE as ASCII string
	Character*20 VNAME
c				Parameter name (from LINE)
	Integer*2 IVAL(4)
c				Parameter value in binary
	Logical LAST
	Integer*4 IER,ITYPE,LC,LEND,LLF,LP,LQ,LSTART,LVN,NC

	Include 'header.cmb'

	JLF = Char (10)
	NULL = Char (0)

	LAST = .false.
	LSTART = 1
	LC = Len (CSTRING)
150	LEND = Index (CSTRING(LSTART:LC),JLF) - 1
	If (LEND .le. 0) LEND = Index (CSTRING(LSTART:LC),';') - 1
	If (LEND .le. 0) Then
	    LAST = .true.
	    LEND = Index (CSTRING(LSTART:LC),NULL) - 1
	    Endif
	If (LEND .le. 0) Return
	LEND = LEND + LSTART - 1
	Call ZFILLC (LINE,100)
	LINE = CSTRING(LSTART:LEND)
	LLF = LEND - LSTART + 1

	LVN = Index (LINE,'=') - 1
	VNAME = LINE (1:LVN)
	If (VNAME(1:3) .eq. 'END') Return
	VNAME(LVN+1:LVN+1) = '$'

	TEMP = LINE(LVN+2:LLF)
	NC = LLF - (LVN+1)
	LQ = Index (TEMP(1:NC),Char(39))
	If (LQ .gt. 0) Then
	    ITYPE = NC - 2
	Else
	    LP = Index (TEMP(1:NC),'.')
	    If (LP .le. 0) Then
		ITYPE = -14
	    Else
		ITYPE = -28
	    Endif
	Endif
	
c	If (VERBOSE) Then
c	    Write(*,151) LINE(1:LLF),VNAME(1:LVN),ITYPE,TEMP(1:NC)
c151	    Format(A,' -> par ',A,' type',I4,' value ',A)
c	    Endif
	If (ITYPE .gt. 0) Then
	    STRING(1:ITYPE) = TEMP(2:NC-1)
	    Call PADNULL (STRING)
	    Call PPUTC (HEADER,VNAME,STRING)
	Else
	    Call ASCBIN (NC,TEMP,ITYPE,IVAL,IER)
	    Call PPUT (HEADER,VNAME,ITYPE,IVAL)
	Endif
	LSTART = LEND + 2
	If (.not. LAST) Go to 150

	Return
	End

c Jan 22 1988	Replace PADSTR call with PADNULL

c Feb 22 1993	Declare undeclared variables 
