c*** File iolib/nextarg.f
c*** June 16, 1995
c*** By Doug Mink, Harvard-Smithsonian Center for Astrophysics

	Subroutine NEXTARG (IARG,NARG,ARGUMENT,LARG)

	Integer*4 IARG
c				Sequence number of argument (incremented)
	Integer*4 NARG
c				Number of arguments
	Character*(*) ARGUMENT
c				Argument returned as null-padded string
	Integer*4 LARG
c				Length of significant part of ARGUMENT
	Integer Iargc

c  If number of command line arguments has not be set, set it

	If (NARG .lt. 0) Then
	    NARG = Iargc ()
	    IARG = 0
	    Endif

c  Get next argument

	IARG = IARG + 1
	If (IARG .gt. NARG) Then
	    LARG = 0
	    Return
	    Endif
	Call Getarg (IARG,ARGUMENT)
	Call PADNULL (ARGUMENT)
	Call VLEN (ARGUMENT,LARG)

	Return
	End
c Jun  5 1992	Program written

c Jun 16 1995	Set number of command line arguments if not set yet
