c*** File iolib/opena.f
c*** February 22, 1993
c*** By Doug Mink

c--- Open file for appending

	Subroutine OPENA (IDEV, FNAME)

	Integer*4 IDEV
c			UNIX file descriptor (returned)
c			If =-2 on entry, then there will be no request
c			for a new file name in case of an error, and IDEV
c			will be unchanged on return in that event.
	Character*(*) FNAME
c			Null-terminated file pathname
c			If error condition arises and IDEV is not =-2, this
c			subroutine will request a new file name from the user.

	Character FNAME0*64
	Integer*4 I, IDEV0, IER, IPOS, LFN

c  Find length of file name and pad with nulls

	Call PADNULL (FNAME)

c  Check for existence of file

10	Call SSEXST (FNAME,IER)

c  If file exists,  check for write permission

	If (IER .eq. 0) then
	   Call SSWRIT (FNAME,IER)
	   If (IER .eq. -1) Then
	      Call ESET
	      Write(*,20) FNAME
20	      Format('OPENA: File "',A,'" is write-protected')

c  If writing is permitted, see if it's an executable file.

	   Else
	      Call SSEXEC (FNAME,IER)
	      If (IER .eq. 0) Then
	         Call ESET
	         Write(*,30) FNAME
30	         Format('OPENA: File "',A,'" is executable')

c  If file exists and can be written into, open it and position
c  the file pointer at its end

	      Else
	         Call SOPEN (IDEV0,2,FNAME)
	         If (IDEV0 .eq. -1) Then
	            Call ESET
	            Write(*,40) FNAME
40	            Format('OPENA: File "',A,'" cannot be opened')
	         Else
	            IDEV = IDEV0
	            Call SLSEEK (IDEV,0,2,IPOS)
	            Return
	         Endif
	      Endif
	   Endif

c  If file does not exist, create it.

	Else
	   Call SOPEN (IDEV0,2,FNAME)
	   If(IDEV0.eq.-1) then
	      Call ESET
	      Write(*,50) FNAME
50	      Format('OPENA: File "',A,'" not found; not creatable')
	   Else
	      IDEV=IDEV0
	      Call SLSEEK (IDEV,0,2,IPOS)
	      Return
	   Endif
	Endif

c  If IDEV=-2 on entry, bail out; otherwise, prompt user for
c  new file name and try again.

	If (IDEV .eq. -2) Return

	Call ENTERC ('Enter new file name (0>none)$',164,FNAME0)
	Call ESET
	LFN = Len (FNAME)
	If ((FNAME0(1:1) .eq. '0') .or. (LFN .le. 0)) Return
	Do 105 I = 1, LFN
105	   FNAME(I:I) = FNAME0(I:I)
	Go to 10
	End
c
c Feb 26 1985	Clean up logic
c		Allow up to 64-character pathnames, up from 50
c		Change error messages to formatted from unformatted
c Jun 21 1985	Use Character filenames in SSx and SOPEN calls

c Jan 22 1988	Replace PADSTR call with PADNULL

c Feb 22 1993	Declare undeclared variables i, idev0, ier, ipos, and lfn
