c*** File iolib/padstr.f
c*** February 22, 1993
c*** By Doug Mink, after Dick French

	Subroutine PADSTR (STRING,LSTR)

c---Replace trailing blanks of string with null

	Character*(*) STRING
c				String, padded with nulls on output
	Integer*4 LSTR
c				Length of string

	Character NULL*1
	Integer*4 I,L,LSIG

	If (LSTR .gt. 0) Then
	    NULL = Char (0)
	    LSIG = Index (STRING(1:LSTR),NULL)

	    If (LSIG .eq. 0) Then

c  Find last non-blank character

		Do 10 I = LSTR, 1, -1
		    If ((STRING(I:I).eq.NULL) .or. (STRING(I:I).eq.' ')) Then
			STRING(I:I) = NULL
		    Else
			Go to 20
		    Endif
10		    Continue
20		Continue

	    Elseif (LSIG .lt. LSTR) Then
		Do 30 L = LSIG, LSTR
30		    STRING(L:L) = NULL
	    Endif
	    Endif

	Return
	End

c Aug 15 1984	Last character is now set to null only if it was blank (rgf)
c		No longer limit length of input string (rgf)
 
c Jun 21 1985	Index check STRING for blanks before loop
c Jun 22 1985	Use 4.2BSD function LNBLNK which checks for last non-blank
c Aug 29 1985	Don't add nulls if a null is already present

c Feb 22 1993	Declare undeclared variables i, l, and lsig
