c*** File iolib/pmerge.f
c*** October 5, 1990
c*** By Doug Mink

	Subroutine PMERGE (PARMS,NEWPARMS)

c--- Replace parameter string values with those from another parameter string

	Character*(*) PARMS
c				Packed FITS parameter string
	Character*(*) NEWPARMS
c				New parameter list
c				(Packed FITS format, NULL, ;  or LF terminated lines

	Character*1 JLF,NULL
c				Linefeed, null
	Character*100 LINE
c				One line of NEWPARMS
	Character*80 VALUE
c				Value of parameter on LINE as ASCII string
	Character*20 VNAME
c				Parameter name (from LINE)
	Logical LAST
	Integer*4 LC,LSTART,LEND,LLF,NC,LVN
	Include 'header.cmb'

	JLF = Char (10)
	NULL = Char (0)
	LAST = .false.

c  Loop through replacement parameters one at a time

	LSTART = 1
	Call VLEN (NEWPARMS,LC)
100	LEND = Index (NEWPARMS(LSTART:LC),JLF) - 1
	If (LEND .le. 0) LEND = Index (NEWPARMS(LSTART:LC),';') - 1
	If (LEND .le. 0) Then
	    LAST = .true.
	    LEND = Index (NEWPARMS(LSTART:LC),NULL) - 1
	    Endif
	If (LEND .le. 0) Return
	LEND = LEND + LSTART - 1
	Call ZFILLC (LINE,100)
	LLF = LEND - LSTART + 1
	LINE(1:LLF) = NEWPARMS(LSTART:LEND)

c  Extract parameter name from line

	LVN = Index (LINE,'=') - 1
	VNAME = LINE (1:LVN)
	If (VNAME(1:3) .eq. 'END') Return
	VNAME(LVN+1:LVN+1) = '$'

c  Get the value (and comment) for this parameter

	VALUE = LINE(LVN+2:LLF)
	NC = LLF - (LVN+1)
	
	If (VERBOSE) Then
	    Write(*,151) LINE(1:LLF),VNAME(1:LVN),VALUE(1:NC)
151	    Format(A,' -> par ',A,' value ',A)
	    Endif

c  Replace the parameter as character string

	Call PADNULL (VALUE)
	Call PPUTC (PARMS,VNAME,VALUE)

c  Set pointer to start of next line

	LSTART = LEND + 2
	If (.not. LAST) Go to 100

	Return
	End

c Jan 22 1988	Replace PADSTR call with PADNULL

c Oct  5 1990	Fix minor errors
