/*** File iolib/sbits.c
 *** December 31, 1986
 *** By Doug Mink
 */

sbits_ (byte,bits,nc1,nc2)

/*   Open UNIX file (Fortran-callable)
 *
 *	Call SBITS (BYTE,BITS) from Fortran
 *
 *	Character*1 BYTE
 *			Byte to convert to bit string
 *	Character*8 BITS
 *			Bit string equivalent to BYTE (returned)
 *
 *	nc1	Number of characters in string BYTE
 *	nc2	Number of characters in string BITS
 *		* these are not explicitly in the calling argument list;
 *		* Fortran puts them there.
 */

unsigned char *byte;
char *bits;

{
register unsigned char b;
	b = *byte;
	if (b & 128) bits[0] = 49;
	else bits[0] = 48;
	if (b & 64) bits[1] = 49;
	else bits[1] = 48;
	if (b & 32) bits[2] = 49;
	else bits[2] = 48;
	if (b & 16) bits[3] = 49;
	else bits[3] = 48;
	if (b & 8) bits[4] = 49;
	else bits[4] = 48;
	if (b & 4) bits[5] = 49;
	else bits[5] = 48;
	if (b & 2) bits[6] = 49;
	else bits[6] = 48;
	if (b & 1) bits[7] = 49;
	else bits[7] = 48;
}
