/*** File iolib/sfdsiz.c
 *** May 7, 1996
 *** By Doug Mink
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>

sfdsiz_ (fd, nbytes)

/*   Find size of UNIX file (Fortran-callable)
 *
 *	Call SFDSIZ (FD, NBYTES) from Fortran
 *
 *	Integer*4 FD
 *			File descriptor
 *	Integer*4 NBYTES
 *			Address of number of bytes in file (returned)
 */

int *fd;
int *nbytes;

{
struct stat buff;
    if (fstat (*fd,&buff))
	*nbytes = -errno;
    else
	*nbytes = (int) buff.st_size;
    return;
}
