/*** File /usr/rgf/test/sfget.c
 *** 8/15/84
 *** Dick French
 */

#include <sys/file.h>
#include </usr/include/stdio.h>

sfget_ (idev,nbytes,buf,nread)

/*   Read from UNIX file (Fortran-callable) using buffered I/O.
 *
 *   Fortran calling sequence : call sfget(idev,nbytes,buf,nread)
 *
 *	idev	Address of UNIX file descriptor (input)
 *
 *	nbytes	Address of number of bytes to read (input)
 *
 *	buf	Address of buffer array (values returned)
 *
 *	nread	Address of number of bytes read (returned, should=nbytes)
 *
 *   Subroutines called : system utility fread
 *
 *   Bugs and restrictions : VAX system routine used
 *
 *   See also:  UNIX manual FREAD(3S)
 *              sfput.man
 *
 *   Revisions :  none
 */

char *buf;
int *nbytes,*nread;
int *idev;

{
FILE *stream;
int nr,nitems,size;

	nitems = *nbytes ;
	size = 1;
	stream = (FILE*)*idev;
	nr = fread(buf,size,nitems,stream);
	*nread = nr;
	
	return;
}
