/*** File iolib/sfgetc.c
 *** May 2, 1985
 *** By Doug Mink, after Dick French
 */

#include <sys/file.h>
#include </usr/include/stdio.h>

sfgetc_ (idev,nbytes,buf,nread,nc)

/*   Read character string from UNIX file (Fortran-callable) using buffered I/O
 *
 *   Fortran calling sequence : Call SFGET (IDEV,NBYTES,BUF,NREAD)
 *
 *	IDEV	Address of UNIX file descriptor (input)
 *		Integer*4
 *
 *	NBYTES	Address of number of bytes to read (input)
 *		Integer*4
 *
 *	BUF	Address of buffer array (values returned)
 *		Character*(*)
 *
 *	NREAD	Address of number of bytes read (returned, should=nbytes)
 *		Integer*4
 *
 *	nc	Number of characters in string buf
 *		* This is not explicitly in the calling argument list;
 *		* Fortran puts it there, necessitating this variation on SPUT
 */

char *buf;
int *nbytes,*nread,*idev,nc;

{
FILE *stream;
int nr,nitems,size;

	nitems = *nbytes ;
	size = 1;
	stream = (FILE*)*idev;
	nr = fread(buf,size,nitems,stream);
	*nread = nr;
	
	return;
}
