/*** File sgetl.c
 *** May 2, 1985
 *** By Doug Mink
 */
#include <sys/file.h>
#include<stdio.h>

sfgetl_ (dev,buf,nread,nc)

/*   Read one line from UNIX file (Fortran-callable)
 *
 *   Fortran calling sequence : Call SFGETL (DEV,BUF,NREAD)
 *
 *	DEV	Address of UNIX file descriptor (input)
 *		Integer*4
 *
 *	BUF	Address of buffer array (values returned)
 *		Character*(*)
 *
 *	NREAD	Address of number of bytes read (returned)
 *		Integer*4
 *
 *	nc	Number of characters in string buf
 *		* This is not explicitly in the calling argument list;
 *		* Fortran puts it there all by itself.
 */
char *buf;
int *dev,*nread,nc;
{
FILE *stream;
int i,idev,nb,nr;
char *s, c;
	stream = (FILE*)*dev;
	nr = nc;
	for (i = 0; i < nr; i++) buf[i] = 0;
	fgets (buf,nr,stream);
	/* printf ("SFGETL: string = %s\n",buf); */
	nb = 0;
	s = buf;
	for (i = 0; i < nr; i++) 
	    {
	    if (*s > 31 || *s == 9) {
		s++;
		nb++; }
	    else break;
	    }
	*nread = nb;
	return;
}
