/*** File iolib/srewind.c
 *** May 20, 1998
 *** By Dick French
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/file.h>

void
srewind_ (idev)

/*   Rewind a UNIX file (Fortran-callable) using rewind
 *
 *   Fortran calling seqence : call srewind(idev)
 *
 *	idev	Address of UNIX file descriptor (input)
 *
 *   Subroutines called : system utility rewind
 *
 *   Bugs and restrictions : VAX system routine used
 *
 *   See also:  UNIX manual FSEEK(3S)
 *              sfseek.man
 *              sftell.man
 *
 *   Revisions : none
 */

int *idev;

{
    FILE *stream;

    stream = (FILE*)*idev;
    rewind(stream);

    return;
}
/* Aug 15 1984	New subroutine
 *
 * May 20 1998	Declare void
 *
 * Mar 24 2008	Include stdio.h and stdlib.h
 */
