/*** File iolib/ssread.c
 *** September 27, 2000
 *** By Dick French, modified by Doug Mink
 */

#include <unistd.h>

void
ssread_ (path,ier,nc)

/*	Fortran-callable UNIX file accessibility check to see if file 
 *	has read permission.
 *
 *	Call SSREAD (PATH,IER) from Fortran
 *
 *	Character*(*) PATH
 *		Address of null-terminated file name (=path name) input
 *
 *	Integer*4 IER
 *		Address of returned error code 
 *		(error code is -1 if read-protected, else 0)
 *		*** Always returns 0 if superuser ***
 *
 *	nc	Number of characters in string buf
 *		* this is not explicitly in the calling argument list;
 *		* Fortran puts it there, necessitating this variation on SPUT
 */

char *path;
int *ier;

{
    *ier = access (path, R_OK);
    return;
}
/* Jun 21 1985	New subroutine
 *
 * May 20 1998	Declare void
 *
 * Sep 27 2000	Include unistd.h instead of sys/file.h
 */
