/*** File iolib/sswap8.c
 *** September 13, 1989
 *** By Doug Mink, CfA
 */

#include <sys/file.h>

sswap8_ (string,nbytes)

/*   Reverse bytes of Integer*4 vector (Fortran-callable)
 *
 *	string	Address of Integer*4 vector
 *
 *	nbytes	Address of number of bytes to reverse
 */

char *string;
int *nbytes;

{
char *sbyte, *slast;
char temp[8];
int nb;

	nb = *nbytes;
	slast = string + nb;
	sbyte = string;
	while (sbyte < slast) {
	    temp[7] = sbyte[0];
	    temp[6] = sbyte[1];
	    temp[5] = sbyte[2];
	    temp[4] = sbyte[3];
	    temp[3] = sbyte[4];
	    temp[2] = sbyte[5];
	    temp[1] = sbyte[6];
	    temp[0] = sbyte[7];
	    sbyte[0] = temp[0];
	    sbyte[1] = temp[1];
	    sbyte[2] = temp[2];
	    sbyte[3] = temp[3];
	    sbyte[4] = temp[4];
	    sbyte[5] = temp[5];
	    sbyte[6] = temp[6];
	    sbyte[7] = temp[7];
	    sbyte = sbyte + 8;
	    }
	return;
}
