/*** File iolib/stent.c
 *** November 2, 1987
 *** By Doug Mink
 */

#include </usr/include/stdio.h>

stent_ (itype,buf,nchar,lchar,nc)

/*   Read terminal entry (Fortran-callable)
 *
 *	itype	Address of entry type
 *
 *	buf	Address of buffer array (values returned)
 *
 *	nchar	Address of number of characters read (value returned)
 *
 *	lchar	Address of last character read (value returned)
 */
char *buf;
int *lchar;
int *nchar,*itype,nc;
{
int iret,ichr,itp,mch,nch,nb,nr,nw;
char jchr,jc[3];

	itp = *itype;
	if (itp > 300) mch = itp - 300;
	else if (itp > 200) mch = itp - 200;
	else if (itp > 100) mch = itp - 100;
	else if (itp == -1 || itp < -30) mch = 1;
	else mch = 99;

	nch = *nchar;
	iret = 0;
	nb = 1;
	rset_();

	while (!iret) {

	    nr = read (stdin,&jchr,nb);
	    ichr = jchr;
	    if (ichr > 128) ichr = ichr = 128;
	    if ((itp > 300 || itp == -1) & (ichr > 96 & ichr < 123))
		ichr = ichr - 32;

	    switch (ichr) {

	    case 10:	nch = 0;	/* linefeed echoes last entry */
			iret = 1;
			break;

	    case 13:	iret = 1;	/* carriage return terminates entry */
			break;

	    case 17:			/* ignore ^S and ^Q */
	    case 19:	break;

	    case 18:	iret = 1;	/* ^R plays back current entry */
			break;

	    case 8:			/* delete on backspace or rubout */
	    case 127:	nch = nch - 1;
			if (nch < 0) nch = 0;
			else {
			    jc[0] = 8;
			    jc[1] = 32;
			    jc[2] = 8;
			    nw = write (stdout,jc,3); }
			break;

	    default:			/* otherwise add character to entry */
			if (nch < 0) nch = 0;
			if (nch <= mch) {
			    jchr = ichr;
			    buf[nch] = jchr;
			    nch = nch ++;
			    nw = write (stdout,&jchr,1);
			    if (mch == 1) iret = 1; }
	    }

	    }

	eset_();
	*lchar = ichr;
	*nchar = nch;
	return;
}
/*
 * Nov  2 1987	New subroutine
 *
 * Nov 13 2001	Change | to || in if statements
 */
