/*** File iolib/stgetc.c
 *** September 19,1990
 *** By Doug Mink
 */

stgetc_ (source,offset,nbytes,dest,ncs,ncd)

/*   Move bytes from character string to another, smaller character string
 *
 *	Call STGETC (SOURCE,OFFSET,NBYTES,DEST)
 *
 *	SOURCE	Address of character string from which to move first byte
 *
 *	OFFSET	Address of offset from start of string
 *
 *	NBYTES	Address of number of bytes to move
 *
 *	DEST	Address of character string to which to move first byte
 */
char *source,*dest;
int *offset,*nbytes;
int ncs,ncd;
{
char *from, *last, *lastd, *to, *len;

/*  Initialize pointers to start and end */
	from = source + *offset;
	to = dest;
	last = from + *nbytes;
	if (ncs < *offset) return;
	if (ncs < *offset + *nbytes) last = from + ncs;
	lastd = dest + (last - from);
	if (ncd < *lastd) last = from + ncd;

/*  Move bytes */
	while (from < last) *(to++) = *(from++);

/*  Pad destination with zeroes */
	if (nbytes < ncd) {
	    lastd = dest + ncd;
	    while (to < lastd) *(to++) = 0;
	    }
	return;
}
