/*** File iolib/vec42.c
 *** February 14, 1989
 *** By Doug Mink, Center for Astrophysics
 */

vec42_ (vec4,vec2,lvec)

/*   Move vector of 4-byte integers into 2-byte integers
 *
 *	vec4	Address of input Integer*4 vector
 *
 *	vec2	Address of output Integer*2 vector
 */

int *vec4;
int *lvec;
short *vec2;

{
unsigned int v;
int v4s,*v4, *veclast;
short *v2, v2i;

	v4 = vec4;
	v2 = vec2;
	veclast = v4 + *lvec + 1;

	while (v4 < veclast) {
	    v4s = *v4++;
	    if (v4s > 32767) v4s = 32767;
	    else if (v4s < -32768) v4s = -32768;
	    *v2++ = (short) v4s;
	    }
	
	return;
}
