/*** File iolib/vecdivr.c
 *** June 4, 1996
 *** By Doug Mink, Center for Astrophysics
 */

vecdivr_ (vecr,lvec,xdiv)

/* Divide a vector of 4-byte floating point numbers by a constant */

float *vecr;	/* Address of output Real*4 vector */
int *lvec;	/* Address of number of elements in vector */
float *xdiv;	/* Address of number by which to divide vector */

{
float *vr, *veclast;

	vr = vecr;
	veclast = vr + *lvec;

	if (*xdiv != 0.) {
	    while (vr < veclast) {
		*vr = *vr / *xdiv;
		vr++;
		/* printf ("%d * %d = %d \n",vr,*xdiv,*vr); */
		}
	    }
	
	return;
}
