/*** File iolib/vecshft4.c
 *** February 14, 1989
 *** By Doug Mink, Center for Astrophysics
 */

vecshft4_ (vec4,lvec,nshft)

/*   Shift vector of 4-byte integers
 *
 *	vec4	Address of input Integer*4 vector
 */

int *vec4;
int *lvec,*nshft;

{
unsigned int v;
int v4s,*v4, *veclast;
int ns;
unsigned int v4i;

	v4 = vec4;
	ns = *nshft;
	veclast = v4 + *lvec + 1;

	if (ns > 0) {
	    while (v4++ < veclast) {
		v4s = *v4;
		v4i = (unsigned) v4s;
		if (v4s < 0) {
		    v4i = -v4s;
		    v = v4i >> ns;
		    *v4 = -v; }
		else
		    *v4 = v4i >> ns;
		/* printf ("%d >> %d = %d %d \n",v4i,ns,v4); */
		}
	    }
	return;
}
