#{ SVDFIT package definition

# Define SVDFIT package

set	svdfitbin		= "svdfit$bin(arch)/"
set	svdscripts		= "svdfit$Scripts/"
package svdfit, bin=svdfitbin$

# Package script tasks
task	svdprep		= "svdfit$x_svdfit.e"
task	svdres		= "svdfit$x_svdfit.e"
task	svdres2		= "svdfit$x_svdfit.e"
task	contres		= "svdfit$contres.par"
task	efast		= "svdscripts$efast.cl"
task	esky		= "svdscripts$esky.cl"
task	esky1		= "svdscripts$esky1.cl"
task	esky2		= "svdscripts$esky2.cl"
task	eskyv		= "svdscripts$eskyv.cl"
task	fileroot	= "svdfit$x_svdfit.e"
task	svdspec		= "svdfit$x_svdfit.e"
task	svdvec		= "svdscripts$svdvec.cl"
task	$esvdvec	= "$"//osfn("svdfitbin$svdvec")
task	contprep	= "svdfit$contprep.par"
hide esvdvec

# Write the welcome message
if (motd)
    type svdfit$svdfit.msg

svdfit.version = "SVDFIT 1.9.3 February 5, 2009"

clbye()
